;CabExtractor v1.0 - Copyright(c)Reel Media Productions
;Created by Paul Leischow, July 18, 2003 
;A simple example showing how to make use of
;the CabExtractor snippet I posted in the 
;Code Snippets section.
;
;CabExtractor interface designed using PureVision
;(PureVision project file (.gui) included in ZIP


;-Init Includes
XIncludeFile "CabExtractor_Constants.pb"
XIncludeFile "CabExtractor_Windows.pb"


;-Init Variables
#DLL            =0
#NO_ERROR       =0
#FILEOP_ABORT   =0
#FILEOP_DOIT    =1
#FILEOP_SKIP    =2

#SPFILENOTIFY_CABINETINFO     =$10
#SPFILENOTIFY_FILEINCABINET   =$11
#SPFILENOTIFY_NEEDNEWCABINET  =$12
#SPFILENOTIFY_FILEEXTRACTED   =$13


;-Init Structures
Structure FileInCabinetInfo
  NameInCabinet.l
  FileSize.l
  Win32Error.l
  DosDate.w
  DosTime.w
  DosAttribs.w
  FullTargetName.b[#MAX_PATH]
EndStructure




;-Init DLL
If OpenLibrary(#DLL,"SetupAPI.dll")
  SetupIterateCabinet=IsFunction(#DLL,"SetupIterateCabinetA")
  Else
  MessageRequester("Error","Could Not Initialize DLL",#MB_ICONERROR)
  End
EndIf



Procedure.l CabinetCallback(Action.l,Notify.l,*Param1.FileInCabinetInfo,Param2.l) 
  Shared ExtractTo$,WildCard$,TotalExtracted.l
  Result=0
  
  Select Notify
    Case #SPFILENOTIFY_FILEEXTRACTED
      If *Param1\Win32Error=0
        TotalExtracted+1
        AddGadgetItem(#Gadget_Extracting_Progress,-1,"Extracted... "+PeekS(*Param1\NameInCabinet))
      EndIf
      Result=*Param1\Win32Error

    Case #SPFILENOTIFY_FILEINCABINET    
      Select Action
        Case #FILEOP_SKIP
          Result=#FILEOP_SKIP
          DosDateTimeToFileTime_(*Param1\DosDate,*Param1\DosTime,FT.FILETIME)
          FileTimeToSystemTime_(FT,ST.SYSTEMTIME)
          Date$=Str(ST\wYear)+"/"+Right("00"+Str(ST\wMonth),2)+"/"+Right("00"+Str(ST\wDay),2)
          AddGadgetItem(#Gadget_Main_Data,-1,PeekS(*Param1\NameInCabinet)+Chr(10)+Str(*Param1\FileSize)+Chr(10)+Date$)          
          
        Case #FILEOP_DOIT
          Result=#FILEOP_SKIP
          strFile$=PeekS(*Param1\NameInCabinet) 
          If WildCard$=""
            Result=#FILEOP_DOIT
            Else
            If FindString(strFile$,WildCard$,1)
              Result=#FILEOP_DOIT  
            EndIf
          EndIf          
          PokeS(@*Param1.FileInCabinetInfo\FullTargetName[0],ExtractTo$+strFile$)
          
      EndSelect
  EndSelect
  ProcedureReturn Result 
EndProcedure




;--------------------
;-Main Loop
If Window_Main()
  lvc.LV_COLUMN
  lvc\mask = #LVCF_FMT 
  lvc\fmt=#LVCFMT_RIGHT  
  SendMessage_(GadgetID(#Gadget_Main_Data),#LVM_SETCOLUMN,1,@lvc)
  lvc\fmt=#LVCFMT_CENTER  
  SendMessage_(GadgetID(#Gadget_Main_Data),#LVM_SETCOLUMN,2,@lvc)
  
  quitMain=0
  Repeat
    EventID=WaitWindowEvent()
    Select EventID
      Case #PB_Event_CloseWindow
        If EventWindowID()=#Window_Main
          quitMain=1
        EndIf

      Case #PB_Event_Gadget
        Select EventGadgetID()
          Case #Gadget_Main_FindFolder
            Folder$=PathRequester("Select Folder to Extract CAB Files","C:\")
            SetGadgetText(#Gadget_Main_Folder,Folder$)
            
          Case #Gadget_Main_Dir 
            ClearGadgetItemList(#Gadget_Main_Data)
            CabName$=GetGadgetText(#Gadget_Main_Dir)         
            If GetGadgetState(#Gadget_Main_Dir)=1              
              If LCase(Right(CabName$,4))=".cab"
                CallFunctionFast(SetupIterateCabinet,CabName$,0,@CabinetCallback(),#FILEOP_SKIP)
              EndIf
            EndIf
            
          Case #Gadget_Main_Extract
            If LCase(Right(CabName$,4))=".cab"
              If Window_Extracting() 
                SetWindowPos_(WindowID(#Window_Extracting),#HWND_TOPMOST,0,0,0,0,16|2|1)                 
                ExtractTo$=GetGadgetText(#Gadget_Main_Folder)
                If ExtractTo$<>""
                  If Right(ExtractTo$,1)<>"\":ExtractTo$+"\":EndIf
                EndIf
                TotalExtracted=0
                If GetGadgetState(#Gadget_Main_Data)=-1
                  WildCard$=""
                  CallFunctionFast(SetupIterateCabinet,CabName$,0,@CabinetCallback(),#FILEOP_DOIT)
                  Else
                  For tmp=0 To CountGadgetItems(#Gadget_Main_Data)-1
                    If GetGadgetItemState(#Gadget_Main_Data,tmp)=#PB_ListIcon_Selected
                      WildCard$=GetGadgetItemText(#Gadget_Main_Data,tmp,0)
                      CallFunctionFast(SetupIterateCabinet,CabName$,0,@CabinetCallback(),#FILEOP_DOIT)                        
                    EndIf
                  Next
                EndIf
                AddGadgetItem(#Gadget_Extracting_Progress,-1,"Done. ("+Str(TotalExtracted)+" files Extracted)")
                SendMessage_(GadgetID(#Gadget_Extracting_Progress),#EM_SETSEL,-1,-1)
                quitExtracting=0
                Repeat
                  If WaitWindowEvent()=#PB_Event_CloseWindow
                    If EventWindowID()=#Window_Extracting
                      quitExtracting=1
                    EndIf
                  EndIf
                Until quitExtracting
                CloseWindow(#Window_Extracting)
              EndIf
            EndIf


        EndSelect

    EndSelect
  Until quitMain
  CloseWindow(#Window_Main)
EndIf

CloseLibrary(#DLL)
End


; ExecutableFormat=Windows
; UseIcon=S:\Cab\CAB\CabExtractor.ICO
; Executable=S:\Cab\CAB\CabExtractor.exe
; DisableDebugger
; EOF